// Copyright (C) 2015 Ryan Curtin
// 
// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at http://mozilla.org/MPL/2.0/.

#if defined(ARMA_USE_SUPERLU)
// First, we need to include all of the SuperLU functionality.  Because SuperLU
// is half-linear-algebra half-disaster, we have to do this in the most stupid
// way possible.  We are unable to include "slu_cdefs.h" and "slu_ddefs.h"
// simultaneously because they both define types with the same name.  So what we
// have to do instead is include one, and then stuff the rest into auxiliary
// namespaces.  That sound you just heard is your brain crying.  The assumption
// that this all hinges on is that the slu_?defs.h files are all copypasta and
// include the same things -- which, as of SuperLU 4.3, they are.  If that
// assumption is untrue, we risk including a system header (like assert.h)
// inside of a namespace, which can cause all sorts of unintended bad behavior
// that will be nigh on impossible to debug.  Woe be unto them who, after hours
// of debugging, come across this comment.  I am truly sorry that it came to
// this.  I had no choice.

// We'll default to sticking the double version in the global namespace.
#include <superlu/slu_ddefs.h>

// The others will be stuffed into slu_? namespaces.  I cringe for future
// generations.
namespace slu_c
  {
  #include <superlu/slu_cdefs.h>
  }

namespace slu_s
  {
  #include <superlu/slu_sdefs.h>
  }

namespace slu_z
  {
  #include <superlu/slu_zdefs.h>
  }

#endif
